#include<stdio.h>
main()
{

	int n,q,a[20],b[20],t[20],u,v,min,h[20],k,i,j,o,e,t1,z[20];


	
	printf("Unesi broj santi:");
	scanf("%d",&n);
	printf("Unesi broj puteva:");
	scanf("%d",&q);
	
	for(i=0;i<n;i++)
	{
		printf("Unesi redni broj sante:");
		scanf("%d",&a[i]);
		printf("Unesi redni broj sante:");
		scanf("%d",&b[i]);
		printf("Unesi vrstu puta(1 ili 0):");
		scanf("%d",&t[i]);				
	}
	
	printf("Unesi poziciju Mike i Laze");
	scanf("%d%d",&u,&v);
	
	for(i=0,t1=0;i<q;i++,t1=0)
	{
	
		if(a[i]==u)
		{
			e=0;
			h[e++]=b[i];	
			k=0;
			if(t1!=t[j])
			{
				k++;
				t1=t[j];

			}
		
			for(j=0;j<q&&h[e-1]!=v;j++)
			{
				if(a[j]==h[e-1])
				{
					h[e++]=b[j];
					if(t1!=t[j])
					{
						k++;
						t1=t[j];

					}
					j=0;
				}
				
			}

			if(h[e-1]==v)
			z[o++]=k;
		}
		
	}
	
	
	for(i=0,min=z[0];i<o;i++)
	if(min>z[i])
	min=z[i];
	
	printf("\n%d",min);
	
}